#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<pair<ll, ll>> reduce(vector<pair<ll, ll>> now){
    vector<pair<ll, ll>> ret;
    sort(now.begin(), now.end());
    for (int i = 0; i < now.size(); i++)
    {
        if(ret.empty()){
            ret.push_back(now[i]);
        }else {
            if(ret.back().second >= now[i].first){
                ret.back().second = now[i].second;
            }else{
                ret.push_back(now[i]);
            }
        }
    }
    return ret;
}

void solve(){
        int n; cin >> n;
    ll a, b; cin >> a >> b;
    vector<ll> d(n - 1);
    for (int i = 0; i < n-1; i++)
    {
        cin >> d[i];
    }
    
    vector<vector<pair<ll, ll>>> ivs;
    vector<pair<ll, ll>> iv = {make_pair(-d[0], -d[0]), make_pair(d[0], d[0])};
    ivs.push_back(iv);
    for (int i = 1; i < n-1; i++)
    {
        vector<pair<ll, ll>> now;
        for(auto [l, r]:iv){
            now.emplace_back(l - d[i], r + d[i]);
            //now.emplace_back(l + d[i], r + d[i]);
        }
        now = reduce(now);
        iv = now;
        ivs.push_back(iv);
    }
    reverse(ivs.begin(), ivs.end());
    // backtrack
    // check if possible
    ll aa = a + b, bb = a - b;
    bool okaa = 0, okbb = 0;
    for(auto [l, r] : iv){
        okaa |= (l <= aa and aa <= r);
        okbb |= (l <= bb and bb <= r);
    }

    if(not okaa or not okbb){
        cout << "NO\n";
        return;
    }
    cout << "YES\n";

    vector<pair<ll, ll>> ans;
    ans.push_back({a, b});
    for (int i = 0; i < n - 1; i++)
    {
        cerr << i << endl;
        vector<ll> an(2, 1e18);
        vector<ll> bn(2, 1e18);
        
        for(auto [l, r] : ivs[i]){
            if(l <= aa and aa <= r){
                an[((l % 2) + 2) % 2] = l;
                if(l + 1 <= r){
                    an[(((l+1) % 2) + 2) % 2] = l;
                }
            }
            if(l <= aa and aa <= r){
                bn[((l % 2) + 2) % 2] = l;
                if(l + 1 <= r){
                    bn[(((l+1) % 2) + 2) % 2] = l;
                }
            }
        }
        
        if(an[0] < 1e18 and bn[0] < 1e18){
            aa = an[0];    
            bb = bn[0];    
        }else if(an[1] < 1e18 and bn[1] < 1e18){
            aa = an[1];    
            bb = bn[1];
        }else{
            assert(false);
        }
        
        ans.push_back({(aa + bb) / 2, (aa - bb) / 2});
        cerr << ans.back().first << " " << ans.back().second << endl;
    }
    reverse(ans.begin(), ans.end());
    for(auto [x, y]:ans) cout << x << " " << y << endl;

}

int main(){
    solve();

    return 0;
}