#include <bits/stdc++.h>
#define state pair<int, pair<int, int>>

using namespace std;

int main() {
    int h, w;
    cin >> h >> w;

    vector<vector<char>> field(h, vector<char>(w));
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            cin >> field[i][j];
        }
    }
    
    pair<int, int> s;
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            if (field[i][j] == 'S') s = {i, j};
        }
    }

    vector<vector<vector<state>>> last(4, vector<vector<state>>(h, vector<state>(w, {-1, {-1, -1}})));
    
    vector<pair<int, pair<int, int>>> T, N;//DULR
    T.push_back({0, s});
    T.push_back({1, s});
    T.push_back({2, s});
    T.push_back({3, s});

    int d = 0;
    while (T.size() || N.size()) {
        if (T.empty()) {
            d++;
            T = N;
            N.clear();
        }

        auto [d, t] = T.back();

        if (last[d][t.first][t.second].first != -1) continue;
 
        pair<int, int> t_ = t;
        T.pop_back();

        if (d == 0) {
            t_.first++;
        }
        if (d == 1) {
            t_.first--;
        }
        if (d == 2) {
            t_.second--;
        }
        if (d == 3) {
            t_.second++;
        }
    }
}